import type { PropType } from 'vue';
import type { BlendFunction, KernelSize } from 'postprocessing';
import type { Object3D, ColorRepresentation } from 'three';
export declare const Outline: import("vue").DefineComponent<{
    /**
     * The objects in the scene which should have an outline.
     */
    outlinedObjects: {
        type: PropType<Object3D<import("three").Event>[]>;
        requred: boolean;
    };
    /**
     * The blend function. Use `BlendFunction.ALPHA` for dark outlines.
     */
    blendFunction: {
        type: PropType<BlendFunction>;
    };
    patternTexture: {
        type: PropType<number>;
    };
    patternScale: {
        type: PropType<number>;
    };
    edgeStrength: {
        type: PropType<number>;
    };
    /**
     * The pulse speed. A value of zero disables the pulse effect.
     */
    pulseSpeed: {
        type: PropType<number>;
    };
    visibleEdgeColor: {
        type: PropType<[r: number, g: number, b: number] | ColorRepresentation>;
    };
    hiddenEdgeColor: {
        type: PropType<[r: number, g: number, b: number] | ColorRepresentation>;
    };
    /**
     * The number of samples used for multisample antialiasing. Requires WebGL 2.
     */
    multisampling: {
        type: PropType<number>;
    };
    resolutionScale: {
        type: PropType<number>;
    };
    resolutionX: {
        type: PropType<number>;
    };
    resolutionY: {
        type: PropType<number>;
    };
    /**
     * The blur kernel size.
     */
    kernelSize: {
        type: PropType<KernelSize>;
    };
    blur: {
        type: PropType<boolean>;
    };
    /**
     * Whether occluded parts of selected objects should be visible
     */
    xRay: {
        type: PropType<boolean>;
    };
}, () => void, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    /**
     * The objects in the scene which should have an outline.
     */
    outlinedObjects: {
        type: PropType<Object3D<import("three").Event>[]>;
        requred: boolean;
    };
    /**
     * The blend function. Use `BlendFunction.ALPHA` for dark outlines.
     */
    blendFunction: {
        type: PropType<BlendFunction>;
    };
    patternTexture: {
        type: PropType<number>;
    };
    patternScale: {
        type: PropType<number>;
    };
    edgeStrength: {
        type: PropType<number>;
    };
    /**
     * The pulse speed. A value of zero disables the pulse effect.
     */
    pulseSpeed: {
        type: PropType<number>;
    };
    visibleEdgeColor: {
        type: PropType<[r: number, g: number, b: number] | ColorRepresentation>;
    };
    hiddenEdgeColor: {
        type: PropType<[r: number, g: number, b: number] | ColorRepresentation>;
    };
    /**
     * The number of samples used for multisample antialiasing. Requires WebGL 2.
     */
    multisampling: {
        type: PropType<number>;
    };
    resolutionScale: {
        type: PropType<number>;
    };
    resolutionX: {
        type: PropType<number>;
    };
    resolutionY: {
        type: PropType<number>;
    };
    /**
     * The blur kernel size.
     */
    kernelSize: {
        type: PropType<KernelSize>;
    };
    blur: {
        type: PropType<boolean>;
    };
    /**
     * Whether occluded parts of selected objects should be visible
     */
    xRay: {
        type: PropType<boolean>;
    };
}>>, {}, {}>;
