/**
 * name: @tresjs/post-processing
 * version: v0.2.1
 * (c) 2023
 * description: Post-processing library for TresJS
 * author: Alvaro Saburido <hola@alvarosaburido.dev> (https://github.com/alvarosabu/)
 */
import { inject as b, getCurrentInstance as D, onMounted as F, nextTick as Y, getCurrentScope as q, onScopeDispose as U, unref as N, toRef as V, readonly as J, customRef as K, ref as h, watch as y, watchEffect as S, computed as G, defineComponent as B, shallowRef as L, provide as Z, renderSlot as _, toRaw as v, onUnmounted as R } from "vue";
import { HalfFloatType as ee, Color as A } from "three";
import { useTres as te, useRenderLoop as ne } from "@tresjs/core";
import { EffectComposer as ae, RenderPass as le, NormalPass as ie, DepthDownsamplingPass as ue, BlendFunction as W, BloomEffect as re, EffectPass as z, GlitchMode as O, GlitchEffect as oe, OutlineEffect as T } from "postprocessing";
function x() {
  const { state: e, setState: n } = b("useTres", te()), l = b("extend") || (() => {
  });
  return {
    state: e,
    setState: n,
    extend: l
  };
}
let g;
function se() {
  var e;
  if (g !== void 0)
    return g;
  try {
    let n;
    const l = document.createElement("canvas");
    return g = !!(window.WebGL2RenderingContext && (n = l.getContext("webgl2"))), n && ((e = n.getExtension("WEBGL_lose_context")) == null || e.loseContext()), g;
  } catch {
    return g = !1;
  }
}
function k(e) {
  return q() ? (U(e), !0) : !1;
}
function H(e) {
  return typeof e == "function" ? e() : N(e);
}
const ce = typeof window < "u", I = () => {
};
function de(...e) {
  if (e.length !== 1)
    return V(...e);
  const n = e[0];
  return typeof n == "function" ? J(K(() => ({ get: n, set: I }))) : h(n);
}
function fe(e, n = !0) {
  D() ? F(e) : n ? e() : Y(e);
}
function me(e) {
  var n;
  const l = H(e);
  return (n = l == null ? void 0 : l.$el) != null ? n : l;
}
const M = ce ? window : void 0;
function ve(...e) {
  let n, l, a, t;
  if (typeof e[0] == "string" || Array.isArray(e[0]) ? ([l, a, t] = e, n = M) : [n, l, a, t] = e, !n)
    return I;
  Array.isArray(l) || (l = [l]), Array.isArray(a) || (a = [a]);
  const o = [], s = () => {
    o.forEach((r) => r()), o.length = 0;
  }, c = (r, u, d, m) => (r.addEventListener(u, d, m), () => r.removeEventListener(u, d, m)), f = y(
    () => [me(n), H(t)],
    ([r, u]) => {
      s(), r && o.push(
        ...l.flatMap((d) => a.map((m) => c(r, d, m, u)))
      );
    },
    { immediate: !0, flush: "post" }
  ), i = () => {
    f(), s();
  };
  return k(i), i;
}
function he() {
  const e = h(!1);
  return D() && F(() => {
    e.value = !0;
  }), e;
}
function ye(e) {
  const n = he();
  return G(() => (n.value, !!e()));
}
function ge(e, n = {}) {
  const { window: l = M } = n, a = ye(() => l && "matchMedia" in l && typeof l.matchMedia == "function");
  let t;
  const o = h(!1), s = () => {
    t && ("removeEventListener" in t ? t.removeEventListener("change", c) : t.removeListener(c));
  }, c = () => {
    a.value && (s(), t = l.matchMedia(de(e).value), o.value = !!(t != null && t.matches), t && ("addEventListener" in t ? t.addEventListener("change", c) : t.addListener(c)));
  };
  return S(c), k(() => s()), o;
}
function be(e = {}) {
  const {
    window: n = M,
    initialWidth: l = 1 / 0,
    initialHeight: a = 1 / 0,
    listenOrientation: t = !0,
    includeScrollbar: o = !0
  } = e, s = h(l), c = h(a), f = () => {
    n && (o ? (s.value = n.innerWidth, c.value = n.innerHeight) : (s.value = n.document.documentElement.clientWidth, c.value = n.document.documentElement.clientHeight));
  };
  if (f(), fe(f), ve("resize", f, { passive: !0 }), t) {
    const i = ge("(orientation: portrait)");
    y(i, () => f());
  }
  return { width: s, height: c };
}
const Ee = /* @__PURE__ */ B({
  __name: "EffectComposer",
  props: {
    enabled: { type: Boolean, default: !0 },
    children: {},
    depthBuffer: { type: Boolean },
    dissableNormalPass: { type: Boolean, default: !1 },
    stencilBuffer: { type: Boolean },
    resolutionScale: {},
    autoClear: { type: Boolean, default: !0 },
    multisampling: { default: 8 },
    frameBufferType: { default: () => ee },
    scene: {},
    camera: {}
  },
  setup(e) {
    const { state: n } = x(), l = L(null), a = e.scene || n.scene, t = e.camera || n.camera;
    let o = null, s = null;
    const c = se();
    Z("effectComposer", l);
    const { width: f, height: i } = be();
    function r() {
      l.value && (s = new ie(e.scene, e.camera), s.enabled = !1, l.value.addPass(s), e.resolutionScale !== void 0 && c && (o = new ue({
        normalBuffer: s.texture,
        resolutionScale: e.resolutionScale
      }), o.enabled = !1, l.value.addPass(o)));
    }
    S(() => {
      n.renderer && (n.renderer.setSize(f.value, i.value), n.renderer.setPixelRatio(Math.min(window.devicePixelRatio, 2)), l.value = new ae(n.renderer, {
        depthBuffer: e.depthBuffer,
        stencilBuffer: e.stencilBuffer,
        multisampling: e.multisampling > 0 && c ? e.multisampling : 0,
        frameBufferType: e.frameBufferType
      }), l.value.addPass(new le(a, t)), e.dissableNormalPass || r());
    });
    const { onLoop: u } = ne();
    return u(() => {
      l.value && l.value.render();
    }), u(({ delta: d }) => {
      if (e.enabled && n.renderer && l.value) {
        const m = n.renderer.autoClear;
        n.renderer.autoClear = e.autoClear, e.stencilBuffer && !e.autoClear && n.renderer.clearStencil(), l.value.render(d), n.renderer.autoClear = m;
      }
    }), (d, m) => _(d.$slots, "default");
  }
}), Pe = /* @__PURE__ */ B({
  __name: "Bloom",
  props: {
    blendFunction: { default: () => W.ADD },
    intensity: { default: 1 },
    blurPass: {},
    width: {},
    height: {},
    kernelSize: {},
    luminanceThreshold: { default: 0.9 },
    luminanceSmoothing: { default: 0.025 },
    mipmapBlur: { type: Boolean, default: !1 }
  },
  setup(e, { expose: n }) {
    const { state: l } = x(), a = b("effectComposer"), t = h(null), o = h(null);
    n({ pass: t, effect: o });
    function s() {
      o.value = new re({
        blendFunction: e.blendFunction,
        mipmapBlur: e.mipmapBlur,
        intensity: e.intensity,
        luminanceThreshold: e.luminanceThreshold,
        luminanceSmoothing: e.luminanceSmoothing
      }), t.value = new z(N(l.camera), v(o.value));
    }
    function c() {
      var r, u;
      (r = o.value) == null || r.dispose(), (u = t.value) == null || u.dispose(), a == null || a.value.removePass(v(t.value));
    }
    const f = y(
      () => [l.camera, a == null ? void 0 : a.value],
      () => {
        var r;
        l.camera && a && a.value && (s(), (r = a == null ? void 0 : a.value) == null || r.addPass(v(t.value)));
      }
    ), i = y(
      () => [e.blendFunction, e.mipmapBlur, e.intensity, e.luminanceThreshold, e.luminanceSmoothing],
      () => {
        var r;
        t.value && (c(), s(), (r = a == null ? void 0 : a.value) == null || r.addPass(v(t.value)));
      }
    );
    return R(() => {
      c(), f(), i();
    }), (r, u) => null;
  }
}), Be = /* @__PURE__ */ B({
  __name: "Glitch",
  props: {
    blendFunction: { default: () => W.ADD },
    delay: {},
    duration: {},
    strength: {},
    mode: {},
    active: { type: Boolean },
    ratio: { default: 0.85 },
    columns: { default: 0.05 },
    chromaticAberrationOffset: {},
    peturbationMap: {},
    dtSize: { default: 64 }
  },
  setup(e, { expose: n }) {
    const { state: l } = x(), a = b("effectComposer"), t = h(null), o = h(null);
    n({ pass: t });
    function s() {
      o.value = new oe({
        blendFunction: e.blendFunction,
        delay: e.delay,
        duration: e.duration,
        strength: e.strength,
        ratio: e.ratio,
        columns: e.columns,
        chromaticAberrationOffset: e.chromaticAberrationOffset,
        dtSize: e.dtSize
      }), t.value = new z(N(l.camera), v(o.value));
    }
    function c() {
      var u, d;
      (u = o.value) == null || u.dispose(), (d = t.value) == null || d.dispose(), a == null || a.value.removePass(v(t.value));
    }
    const f = y(
      () => [l.camera, a == null ? void 0 : a.value],
      () => {
        var u;
        l.camera && a && a.value && (s(), (u = a == null ? void 0 : a.value) == null || u.addPass(v(t.value)));
      }
    ), i = y(
      () => [e.delay, e.duration, e.strength, e.ratio, e.columns, e.chromaticAberrationOffset, e.peturbationMap, e.dtSize],
      () => {
        var u;
        t.value && (a == null || a.value.removePass(v(t.value)), s(), (u = a == null ? void 0 : a.value) == null || u.addPass(v(t.value)));
      }
    );
    S(() => {
      t.value && (t.value.mode = e.active ? e.mode || O.SPORADIC : O.DISABLED);
    });
    const r = y(
      () => e.active,
      (u) => {
        t.value && (t.value.enabled = u);
      }
    );
    return R(() => {
      c(), f(), i(), r();
    }), (u, d) => null;
  }
}), xe = B({
  name: "Outline",
  props: {
    /**
     * The objects in the scene which should have an outline.
     */
    outlinedObjects: {
      type: Array,
      requred: !0
    },
    /**
     * The blend function. Use `BlendFunction.ALPHA` for dark outlines.
     */
    blendFunction: {
      type: Number
    },
    patternTexture: {
      type: Number
    },
    patternScale: {
      type: Number
    },
    edgeStrength: {
      type: Number
    },
    /**
     * The pulse speed. A value of zero disables the pulse effect.
     */
    pulseSpeed: {
      type: Number
    },
    visibleEdgeColor: {
      type: [String, Number, Array]
    },
    hiddenEdgeColor: {
      type: [String, Number, Array]
    },
    /**
     * The number of samples used for multisample antialiasing. Requires WebGL 2.
     */
    multisampling: {
      type: Number
    },
    resolutionScale: {
      type: Number
    },
    resolutionX: {
      type: Number
    },
    resolutionY: {
      type: Number
    },
    /**
     * The blur kernel size.
     */
    kernelSize: {
      type: Number
    },
    blur: {
      type: Boolean
    },
    /**
     * Whether occluded parts of selected objects should be visible
     */
    xRay: {
      type: Boolean
    }
  },
  setup(e) {
    const { state: n } = x(), l = b("effectComposer"), a = L(null), t = L(null), o = (i) => i instanceof A ? i : Array.isArray(i) ? new A(...i) : new A(i), s = (i) => i !== void 0 ? o(i).getHex() : void 0, c = G(() => {
      const {
        blur: i,
        xRay: r,
        kernelSize: u,
        pulseSpeed: d,
        resolutionX: m,
        resolutionY: p,
        patternScale: w,
        edgeStrength: C,
        blendFunction: E,
        multisampling: P,
        patternTexture: $,
        resolutionScale: j,
        hiddenEdgeColor: Q,
        visibleEdgeColor: X
      } = e;
      return {
        blur: i,
        xRay: r,
        kernelSize: u,
        pulseSpeed: d,
        resolutionX: m,
        resolutionY: p,
        patternScale: w,
        edgeStrength: C,
        blendFunction: E,
        multisampling: P,
        patternTexture: $,
        resolutionScale: j,
        hiddenEdgeColor: s(Q),
        visibleEdgeColor: s(X)
      };
    }), f = S(() => {
      var i;
      n.camera && l && l.value && n.scene && (t.value = new T(n.scene, n.camera, c.value), a.value = new z(n.camera, t.value), (i = l.value) == null || i.addPass(a.value), f());
    });
    return y(
      [() => e.outlinedObjects, t],
      // whatchEffect is intentionally not used here as it would result in an endless loop
      () => {
        var i;
        (i = t.value) == null || i.selection.set(e.outlinedObjects || []);
      },
      {
        immediate: !0
      }
    ), S(() => {
      if (!t.value)
        return;
      const i = new T(), {
        blur: r,
        xRay: u,
        kernelSize: d,
        pulseSpeed: m,
        patternScale: p,
        edgeStrength: w,
        multisampling: C,
        hiddenEdgeColor: E,
        visibleEdgeColor: P
      } = c.value;
      t.value.blur = r !== void 0 ? r : i.blur, t.value.xRay = u !== void 0 ? u : i.xRay, t.value.pulseSpeed = m !== void 0 ? m : i.pulseSpeed, t.value.kernelSize = d !== void 0 ? d : i.kernelSize, t.value.edgeStrength = w !== void 0 ? w : i.edgeStrength, t.value.patternScale = p !== void 0 ? p : i.patternScale, t.value.multisampling = C !== void 0 ? C : i.multisampling, t.value.hiddenEdgeColor = E !== void 0 ? o(E) : i.hiddenEdgeColor, t.value.visibleEdgeColor = P !== void 0 ? o(P) : i.visibleEdgeColor, i.dispose();
    }), R(() => {
      var i, r, u, d;
      (i = t.value) == null || i.selection.clear(), (r = l.value) == null || r.removePass(a.value), (u = t.value) == null || u.dispose(), (d = a.value) == null || d.dispose();
    }), () => {
    };
  }
});
export {
  Pe as Bloom,
  Ee as EffectComposer,
  Be as Glitch,
  xe as Outline
};
